diff --git a/changelog b/changelog
index 2a9f666..1e53de8 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,5 @@
+20081225 tpd src/axiom-website/patches.html 20081225.04.tpd.patch
+20081225 tpd src/algebra/Makefile move layers 15-19
 20081225 tpd src/axiom-website/patches.html 20081225.03.tpd.patch
 20081225 tpd src/algebra/Makefile move layers 11, 12, 13
 20081225 tpd src/axiom-website/patches.html 20081225.02.tpd.patch
diff --git a/src/algebra/Makefile.pamphlet b/src/algebra/Makefile.pamphlet
index a60cf0f..4335faf 100644
--- a/src/algebra/Makefile.pamphlet
+++ b/src/algebra/Makefile.pamphlet
@@ -380,6 +380,7 @@ LAYER9=\
 @
 \subsection{Layer10}
 Depends on: IVECTOR PTCAT STRICAT
+Used by next layer: DIRPCAT FAXF PFECAT STRING
 <<layer10>>=
 
 LAYER10=\
@@ -397,252 +398,184 @@ LAYER10=\
 
 @
 \subsection{Layer11}
-
+Depends on: DIRPCAT FAXF PFECAT STRING
+Used by next layer: DIOPS DPOLCAT FINRALG FRAC RMATCAT RRCC UPXSCAT
 <<layer11>>=
 
 LAYER11=\
+  ${OUT}/ASP1.o     ${OUT}/ASP10.o    ${OUT}/ASP24.o    ${OUT}/ASP4.o     \
+  ${OUT}/ASP50.o    ${OUT}/ASP6.o     ${OUT}/ASP73.o    ${OUT}/AXSERV.o   \
+  ${OUT}/BALFACT.o  ${OUT}/BEZOUT.o   ${OUT}/BINARY.o   ${OUT}/BINFILE.o  \
+  ${OUT}/BOUNDZRO.o ${OUT}/BPADICRT.o ${OUT}/BRILL.o    ${OUT}/CDEN.o     \
+  ${OUT}/CHVAR.o    ${OUT}/COMMUPC.o  ${OUT}/CONTFRAC.o ${OUT}/CVMP.o     \
+  ${OUT}/CYCLOTOM.o ${OUT}/CYCLES.o   ${OUT}/DDFACT.o   ${OUT}/DECIMAL.o  \
+  ${OUT}/DIOPS.o    ${OUT}/DIOPS-.o   ${OUT}/DIRPROD.o  ${OUT}/DISPLAY.o  \
+  ${OUT}/DMP.o      ${OUT}/DPMO.o     ${OUT}/DPOLCAT.o  ${OUT}/DPOLCAT-.o \
+  ${OUT}/D01AJFA.o  ${OUT}/D01AKFA.o  ${OUT}/D01ALFA.o  ${OUT}/D01AMFA.o  \
+  ${OUT}/D01APFA.o  ${OUT}/D01AQFA.o  ${OUT}/EMR.o      ${OUT}/EQ.o       \
+  ${OUT}/ERROR.o    ${OUT}/EVALCYC.o  ${OUT}/E04DGFA.o  ${OUT}/E04FDFA.o  \
+  ${OUT}/E04GCFA.o  ${OUT}/E04JAFA.o  ${OUT}/FACUTIL.o  ${OUT}/FF.o       \
+  ${OUT}/FFCG.o     ${OUT}/FFCGX.o    ${OUT}/FFFG.o     ${OUT}/FFFGF.o    \
+  ${OUT}/FFHOM.o    ${OUT}/FFNB.o     ${OUT}/FFNBX.o    ${OUT}/FFPOLY.o   \
+  ${OUT}/FFX.o      ${OUT}/FFSLPE.o   ${OUT}/FGLMICPK.o ${OUT}/FILE.o     \
+  ${OUT}/FINAALG.o  ${OUT}/FINAALG-.o ${OUT}/FINRALG.o  ${OUT}/FINRALG-.o \
+  ${OUT}/FFF.o      ${OUT}/FLOATRP.o  ${OUT}/FNAME.o    ${OUT}/FOP.o      \
+  ${OUT}/FORMULA.o  ${OUT}/FORT.o     ${OUT}/FRAC.o     ${OUT}/FTEM.o     \
+  ${OUT}/GENEEZ.o   ${OUT}/GENMFACT.o ${OUT}/GENPGCD.o  ${OUT}/GALFACTU.o \
+  ${OUT}/GALPOLYU.o ${OUT}/GB.o       ${OUT}/GBEUCLID.o ${OUT}/GBF.o      \
+  ${OUT}/GBINTERN.o ${OUT}/GHENSEL.o  ${OUT}/GMODPOL.o  ${OUT}/GOSPER.o   \
+  ${OUT}/GRIMAGE.o  ${OUT}/GROEBSOL.o ${OUT}/HDMP.o     ${OUT}/HDP.o      \
+  ${OUT}/HEXADEC.o  ${OUT}/HEUGCD.o   ${OUT}/IBPTOOLS.o ${OUT}/IFF.o      \
+  ${OUT}/IBITS.o    ${OUT}/ICARD.o    ${OUT}/ICDEN.o    ${OUT}/IDECOMP.o  \
+  ${OUT}/IIARRAY2.o ${OUT}/IMATLIN.o  ${OUT}/IMATQF.o   ${OUT}/INMODGCD.o \
+  ${OUT}/INNMFACT.o ${OUT}/INPSIGN.o  ${OUT}/INTHERTR.o ${OUT}/INTRAT.o   \
+  ${OUT}/INTRF.o    ${OUT}/INTSLPE.o  ${OUT}/INTTR.o    ${OUT}/ISUMP.o    \
+  ${OUT}/LAUPOL.o   ${OUT}/LEADCDET.o ${OUT}/LGROBP.o   ${OUT}/LIMITRF.o  \
+  ${OUT}/LINDEP.o   ${OUT}/LO.o       ${OUT}/LPEFRAC.o  ${OUT}/LSPP.o     \
+  ${OUT}/MATLIN.o   ${OUT}/MCDEN.o    ${OUT}/MDDFACT.o  ${OUT}/MFINFACT.o \
+  ${OUT}/MFLOAT.o   ${OUT}/MINT.o     ${OUT}/MLIFT.o    ${OUT}/MMAP.o     \
+  ${OUT}/MODMON.o   ${OUT}/MONOTOOL.o ${OUT}/MPCPF.o    ${OUT}/MPC2.o     \
+  ${OUT}/MPC3.o     ${OUT}/MPOLY.o    ${OUT}/MPRFF.o    ${OUT}/MRATFAC.o  \
+  ${OUT}/MULTSQFR.o ${OUT}/NORMRETR.o ${OUT}/NPCOEF.o   ${OUT}/NSUP.o     \
+  ${OUT}/NTPOLFN.o  ${OUT}/ODP.o      ${OUT}/ODEPRIM.o  ${OUT}/ODEPRRIC.o \
+  ${OUT}/OMPKG.o    ${OUT}/OMSERVER.o ${OUT}/PADEPAC.o  ${OUT}/PADICRAT.o \
+  ${OUT}/PADICRC.o  ${OUT}/PCOMP.o    ${OUT}/PDECOMP.o  ${OUT}/PF.o       \
+  ${OUT}/PFBR.o     ${OUT}/PFBRU.o    ${OUT}/PFOTOOLS.o ${OUT}/PFRPAC.o   \
+  ${OUT}/PGCD.o     ${OUT}/PINTERPA.o ${OUT}/PLEQN.o    ${OUT}/PMPLCAT.o  \
+  ${OUT}/PMQFCAT.o  ${OUT}/PNTHEORY.o ${OUT}/POLUTIL.o  ${OUT}/POLTOPOL.o \
+  ${OUT}/POLYCATQ.o ${OUT}/POLYLIFT.o ${OUT}/POLYROOT.o ${OUT}/POLY2.o    \
+  ${OUT}/POLY2UP.o  ${OUT}/PRS.o      ${OUT}/PSQFR.o    ${OUT}/PUSHVAR.o  \
+  ${OUT}/QALGSET.o  ${OUT}/QFCAT2.o   ${OUT}/RADIX.o    ${OUT}/RATFACT.o  \
+  ${OUT}/RCFIELD.o  ${OUT}/RCFIELD-.o ${OUT}/RDETR.o    ${OUT}/RDETRS.o   \
+  ${OUT}/REAL0.o    ${OUT}/REAL0Q.o   ${OUT}/REALSOLV.o ${OUT}/RESRING.o  \
+  ${OUT}/RETSOL.o   ${OUT}/RF.o       ${OUT}/RFFACTOR.o ${OUT}/RMATCAT.o  \
+  ${OUT}/RMATCAT-.o ${OUT}/RRCC.o     ${OUT}/RRCC-.o    ${OUT}/SCPKG.o    \
+  ${OUT}/SHDP.o     ${OUT}/SHP.o      ${OUT}/SIGNRF.o   ${OUT}/SMITH.o    \
+  ${OUT}/SMP.o      ${OUT}/SMTS.o     ${OUT}/SOLVEFOR.o ${OUT}/SPLTREE.o  \
+  ${OUT}/STINPROD.o ${OUT}/STTFNC.o   ${OUT}/SUBRESP.o  ${OUT}/SUMRF.o    \
+  ${OUT}/SUP.o      ${OUT}/SUPEXPR.o  ${OUT}/SUPFRACF.o ${OUT}/TANEXP.o   \
+  ${OUT}/TEMUTL.o   ${OUT}/TEX.o      ${OUT}/TEXTFILE.o ${OUT}/TREE.o     \
+  ${OUT}/TWOFACT.o  ${OUT}/UNIFACT.o  ${OUT}/UP.o       ${OUT}/UPCDEN.o   \
+  ${OUT}/UPDECOMP.o ${OUT}/UPDIVP.o   ${OUT}/UPMP.o     ${OUT}/UPOLYC2.o  \
+  ${OUT}/UPXSCAT.o  ${OUT}/UPSQFREE.o ${OUT}/VIEWDEF.o  ${OUT}/VIEW2D.o   \
+  ${OUT}/VOID.o     ${OUT}/WEIER.o    ${OUT}/WP.o \
   layer11done
 
 @
 \subsection{Layer12}
-
+Depends on: DIOPS DPOLCAT FINRALG FRAC RMATCAT RRCC UPXSCAT
+Used by next layer: DIAGG FRAMALG MDAGG SMATCAT UPXSCCA
 <<layer12>>=
 
 LAYER12=\
+  ${OUT}/DIAGG.o   ${OUT}/DIAGG-.o   ${OUT}/DSMP.o     ${OUT}/EXPUPXS.o \
+  ${OUT}/FRAMALG.o ${OUT}/FRAMALG-.o ${OUT}/MDAGG.o    ${OUT}/ODPOL.o   \
+  ${OUT}/PLOT.o    ${OUT}/RMCAT2.o   ${OUT}/ROIRC.o    ${OUT}/SDPOL.o   \
+  ${OUT}/SMATCAT.o ${OUT}/SMATCAT-.o ${OUT}/TUBETOOL.o ${OUT}/UPXSCCA.o \
+  ${OUT}/UPXSCCA-.o \
   layer12done
 
 @
 \subsection{Layer13}
-
+Depends on: DIAGG FRAMALG MDAGG SMATCAT UPXSCCA
+Used by next layer: FSAGG KDAGG MSETAGG MONOGEN
 <<layer13>>=
 
 LAYER13=\
+  ${OUT}/DPMM.o     ${OUT}/EFUPXS.o  ${OUT}/FFINTBAS.o ${OUT}/FRIDEAL.o  \
+  ${OUT}/FRIDEAL2.o ${OUT}/FRMOD.o   ${OUT}/FSAGG.o    ${OUT}/FSAGG-.o   \
+  ${OUT}/IBATOOL.o  ${OUT}/INTFACT.o ${OUT}/KDAGG.o    ${OUT}/KDAGG-.o   \
+  ${OUT}/MSETAGG.o  ${OUT}/MONOGEN.o ${OUT}/MONOGEN-.o ${OUT}/NFINTBAS.o \
+  ${OUT}/SPACE3.o  \
   layer13done
 
 @
 \subsection{Layer14}
-
+Depends on: FSAGG KDAGG MSETAGG MONOGEN
+Used by next layer: TBAGG
 <<layer14>>=
 
 LAYER14=\
-  ${OUT}/ASP1.o     ${OUT}/ASP10.o    ${OUT}/ASP24.o    ${OUT}/ASP4.o     \
-  ${OUT}/ASP50.o    ${OUT}/ASP6.o     ${OUT}/ASP73.o    ${OUT}/AXSERV.o   \
-  ${OUT}/BALFACT.o  \
-  ${OUT}/BEZOUT.o   ${OUT}/BINARY.o   ${OUT}/BINFILE.o  ${OUT}/BOUNDZRO.o \
-  ${OUT}/BPADICRT.o ${OUT}/BRILL.o    ${OUT}/CDEN.o     ${OUT}/CHVAR.o    \
-  ${OUT}/COMMUPC.o  ${OUT}/CONTFRAC.o ${OUT}/CVMP.o     ${OUT}/CYCLOTOM.o \
-  ${OUT}/CYCLES.o   ${OUT}/DDFACT.o   ${OUT}/DECIMAL.o  ${OUT}/DIOPS.o    \
-  ${OUT}/DIOPS-.o   ${OUT}/DIRPROD.o  ${OUT}/DISPLAY.o  ${OUT}/DMP.o      \
-  ${OUT}/DPMO.o     ${OUT}/DPOLCAT.o  ${OUT}/DPOLCAT-.o ${OUT}/D01AJFA.o  \
-  ${OUT}/D01AKFA.o  ${OUT}/D01ALFA.o  ${OUT}/D01AMFA.o  ${OUT}/D01APFA.o  \
-  ${OUT}/D01AQFA.o  ${OUT}/EMR.o      ${OUT}/EQ.o       ${OUT}/ERROR.o    \
-  ${OUT}/EVALCYC.o  ${OUT}/E04DGFA.o  ${OUT}/E04FDFA.o  ${OUT}/E04GCFA.o  \
-  ${OUT}/E04JAFA.o  ${OUT}/FACUTIL.o  ${OUT}/FF.o       ${OUT}/FFCG.o     \
-  ${OUT}/FFCGX.o    ${OUT}/FFFG.o \
-  ${OUT}/FFHOM.o    ${OUT}/FFNB.o     ${OUT}/FFNBX.o    \
-  ${OUT}/FFPOLY.o   ${OUT}/FFX.o      ${OUT}/FFSLPE.o   ${OUT}/FGLMICPK.o \
-  ${OUT}/FILE.o     ${OUT}/FINAALG.o  ${OUT}/FINAALG-.o ${OUT}/FINRALG.o  \
-  ${OUT}/FINRALG-.o ${OUT}/FFF.o      ${OUT}/FLOATRP.o  ${OUT}/FNAME.o    \
-  ${OUT}/FOP.o      ${OUT}/FORMULA.o  ${OUT}/FORT.o     ${OUT}/FRAC.o     \
-  ${OUT}/FTEM.o     ${OUT}/GENEEZ.o   ${OUT}/GENMFACT.o ${OUT}/GENPGCD.o  \
-  ${OUT}/GALFACTU.o ${OUT}/GALPOLYU.o ${OUT}/GB.o       ${OUT}/GBEUCLID.o \
-  ${OUT}/GBF.o      ${OUT}/GBINTERN.o ${OUT}/GHENSEL.o  ${OUT}/GMODPOL.o  \
-  ${OUT}/GOSPER.o   ${OUT}/GRIMAGE.o  ${OUT}/GROEBSOL.o ${OUT}/HDMP.o     \
-  ${OUT}/HDP.o      ${OUT}/HEXADEC.o  ${OUT}/HEUGCD.o   ${OUT}/IBPTOOLS.o \
-  ${OUT}/IFF.o      ${OUT}/IBITS.o    ${OUT}/ICARD.o    ${OUT}/ICDEN.o    \
-  ${OUT}/IDECOMP.o  ${OUT}/IIARRAY2.o ${OUT}/IMATLIN.o  ${OUT}/IMATQF.o   \
-  ${OUT}/INMODGCD.o ${OUT}/INNMFACT.o ${OUT}/INPSIGN.o  ${OUT}/INTHERTR.o \
-  ${OUT}/INTRAT.o   ${OUT}/INTRF.o    ${OUT}/INTSLPE.o  ${OUT}/INTTR.o    \
-  ${OUT}/ISUMP.o    ${OUT}/LAUPOL.o   ${OUT}/LEADCDET.o ${OUT}/LGROBP.o   \
-  ${OUT}/LIMITRF.o  ${OUT}/LINDEP.o   ${OUT}/LO.o       ${OUT}/LPEFRAC.o  \
-  ${OUT}/LSPP.o     ${OUT}/MATLIN.o   ${OUT}/MCDEN.o    ${OUT}/MDDFACT.o  \
-  ${OUT}/MFINFACT.o ${OUT}/MFLOAT.o   ${OUT}/MINT.o     ${OUT}/MLIFT.o    \
-  ${OUT}/MMAP.o     ${OUT}/MODMON.o   ${OUT}/MONOTOOL.o ${OUT}/MPCPF.o    \
-  ${OUT}/MPC2.o     ${OUT}/MPC3.o     ${OUT}/MPOLY.o    ${OUT}/MPRFF.o    \
-  ${OUT}/MRATFAC.o  ${OUT}/MULTSQFR.o ${OUT}/NORMRETR.o ${OUT}/NPCOEF.o   \
-  ${OUT}/NSUP.o     ${OUT}/NTPOLFN.o  ${OUT}/ODP.o      ${OUT}/ODEPRIM.o  \
-  ${OUT}/ODEPRRIC.o ${OUT}/OMPKG.o    ${OUT}/OMSERVER.o ${OUT}/PADEPAC.o  \
-  ${OUT}/PADICRAT.o ${OUT}/PADICRC.o  ${OUT}/PCOMP.o    ${OUT}/PDECOMP.o  \
-  ${OUT}/PF.o       ${OUT}/PFBR.o     ${OUT}/PFBRU.o    ${OUT}/PFOTOOLS.o \
-  ${OUT}/PFRPAC.o   ${OUT}/PGCD.o     ${OUT}/PINTERPA.o ${OUT}/PLEQN.o    \
-  ${OUT}/PMPLCAT.o  ${OUT}/PMQFCAT.o  ${OUT}/PNTHEORY.o ${OUT}/POLUTIL.o  \
-  ${OUT}/POLTOPOL.o ${OUT}/POLYCATQ.o ${OUT}/POLYLIFT.o ${OUT}/POLYROOT.o \
-  ${OUT}/POLY2.o    ${OUT}/POLY2UP.o  ${OUT}/PRS.o      ${OUT}/PSQFR.o    \
-  ${OUT}/PUSHVAR.o  ${OUT}/QALGSET.o  ${OUT}/QFCAT2.o   ${OUT}/RADIX.o    \
-  ${OUT}/RATFACT.o  ${OUT}/RCFIELD.o  ${OUT}/RCFIELD-.o ${OUT}/RDETR.o    \
-  ${OUT}/RDETRS.o   ${OUT}/REAL0.o    ${OUT}/REAL0Q.o   ${OUT}/REALSOLV.o \
-  ${OUT}/RESRING.o  ${OUT}/RETSOL.o   ${OUT}/RF.o       ${OUT}/RFFACTOR.o \
-  ${OUT}/RMATCAT.o  ${OUT}/RMATCAT-.o ${OUT}/RRCC.o     ${OUT}/RRCC-.o    \
-  ${OUT}/SCPKG.o    ${OUT}/SHDP.o     ${OUT}/SHP.o      ${OUT}/SIGNRF.o   \
-  ${OUT}/SMITH.o    ${OUT}/SMP.o      ${OUT}/SMTS.o     ${OUT}/SOLVEFOR.o \
-  ${OUT}/SPLTREE.o  ${OUT}/STINPROD.o ${OUT}/STTFNC.o   ${OUT}/SUBRESP.o  \
-  ${OUT}/SUMRF.o    ${OUT}/SUP.o      ${OUT}/SUPEXPR.o \
-  ${OUT}/SUPFRACF.o ${OUT}/TANEXP.o   \
-  ${OUT}/TEMUTL.o   ${OUT}/TEX.o      ${OUT}/TEXTFILE.o ${OUT}/TREE.o     \
-  ${OUT}/TWOFACT.o  ${OUT}/UNIFACT.o  ${OUT}/UP.o       ${OUT}/UPCDEN.o   \
-  ${OUT}/UPDECOMP.o ${OUT}/UPDIVP.o   ${OUT}/UPMP.o     ${OUT}/UPOLYC2.o  \
-  ${OUT}/UPXSCAT.o  ${OUT}/UPSQFREE.o ${OUT}/VIEWDEF.o  ${OUT}/VIEW2D.o   \
-  ${OUT}/VOID.o     ${OUT}/WEIER.o    ${OUT}/WP.o \
+  ${OUT}/CCLASS.o   ${OUT}/FSAGG2.o  ${OUT}/GALFACT.o ${OUT}/IALGFACT.o \
+  ${OUT}/IBACHIN.o  ${OUT}/MMLFORM.o ${OUT}/NORMMA.o  ${OUT}/ODERED.o   \
+  ${OUT}/OMSAGG.o   ${OUT}/PERM.o    ${OUT}/PERMGRP.o ${OUT}/PRIMES.o   \
+  ${OUT}/PWFFINTB.o ${OUT}/RDIST.o   ${OUT}/SAE.o     ${OUT}/SAEFACT.o  \
+  ${OUT}/SAERFFC.o  ${OUT}/SGCF.o    ${OUT}/TBAGG.o   ${OUT}/TBAGG-.o   \
+  ${OUT}/VIEW3D.o   ${OUT}/WFFINTBS.o  \
   layer14done
 
 @
 \subsection{Layer15}
-\subsubsection{Completed spad files}
-\begin{verbatim}
-plot.spad.pamphlet (PLOT PLOT1)
-\end{verbatim}
-
+Depends on: TBAGG
+Used by next layer: ALIST
 <<layer15>>=
 
 LAYER15=\
-  ${OUT}/DIAGG.o   ${OUT}/DIAGG-.o   ${OUT}/DSMP.o     ${OUT}/EXPUPXS.o \
-  ${OUT}/FFFGF.o \
-  ${OUT}/FRAMALG.o ${OUT}/FRAMALG-.o ${OUT}/MDAGG.o    ${OUT}/ODPOL.o   \
-  ${OUT}/PLOT.o    ${OUT}/RMCAT2.o   ${OUT}/ROIRC.o    ${OUT}/SDPOL.o   \
-  ${OUT}/SMATCAT.o ${OUT}/SMATCAT-.o ${OUT}/TUBETOOL.o ${OUT}/UPXSCCA.o \
-  ${OUT}/UPXSCCA-.o \
+  ${OUT}/ALIST.o   ${OUT}/EQTBL.o   ${OUT}/GSTBL.o   ${OUT}/HASHTBL.o \
+  ${OUT}/INTABL.o  ${OUT}/INTFTBL.o ${OUT}/INTPACK.o ${OUT}/IPF.o     \
+  ${OUT}/KAFILE.o  ${OUT}/PATRES.o  ${OUT}/STBL.o    ${OUT}/STRTBL.o  \
+  ${OUT}/TABLE.o   ${OUT}/TBCMPPK.o  \
   layer15done
 
 @
 \subsection{Layer16}
-\subsubsection{Completed spad files}
-\begin{verbatim}
-efupxs.spad.pamphlet (EFUPXS)
-lodop.spad.pamphlet (MLO OMLO NCODIV ODR DPMO DPMM)
-space.spad.pamphlet (SPACEC SPACE3 TOPSP)
-\end{verbatim}
-
+Depends on: ALIST
 <<layer16>>=
 
 LAYER16=\
-  ${OUT}/DPMM.o     ${OUT}/EFUPXS.o  ${OUT}/FFINTBAS.o ${OUT}/FRIDEAL.o  \
-  ${OUT}/FRIDEAL2.o ${OUT}/FRMOD.o   ${OUT}/FSAGG.o    ${OUT}/FSAGG-.o   \
-  ${OUT}/IBATOOL.o  ${OUT}/INTFACT.o ${OUT}/KDAGG.o    ${OUT}/KDAGG-.o   \
-  ${OUT}/MSETAGG.o  ${OUT}/MONOGEN.o ${OUT}/MONOGEN-.o ${OUT}/NFINTBAS.o \
-  ${OUT}/SPACE3.o  \
+  ${OUT}/ACF.o      ${OUT}/ACF-.o     ${OUT}/ACPLOT.o   ${OUT}/ANTISYM.o  \
+  ${OUT}/ANY.o      ${OUT}/ASP12.o    ${OUT}/ASP27.o    ${OUT}/ASP28.o    \
+  ${OUT}/ASP33.o    ${OUT}/ASP49.o    ${OUT}/ASP55.o    ${OUT}/ASP7.o     \
+  ${OUT}/ASP78.o    ${OUT}/ASP8.o     ${OUT}/ASP9.o     ${OUT}/ATTRBUT.o  \
+  ${OUT}/BOP.o      ${OUT}/BOP1.o     ${OUT}/COMMONOP.o ${OUT}/COMPCAT.o  \
+  ${OUT}/COMPCAT-.o ${OUT}/DRAW.o     ${OUT}/DRAWCFUN.o ${OUT}/DROPT.o    \
+  ${OUT}/DROPT0.o   ${OUT}/D01ANFA.o  ${OUT}/D01ASFA.o  ${OUT}/D03AGNT.o  \
+  ${OUT}/EP.o       ${OUT}/E04AGNT.o  ${OUT}/FCPAK1.o   ${OUT}/FEXPR.o    \
+  ${OUT}/FFCAT.o    ${OUT}/FFCAT-.o   ${OUT}/FFCGP.o    ${OUT}/FFNBP.o    \
+  ${OUT}/FFP.o      ${OUT}/FLOAT.o    ${OUT}/FPARFRAC.o ${OUT}/FR.o       \
+  ${OUT}/FRNAALG.o  ${OUT}/FRNAALG-.o ${OUT}/FS.o       ${OUT}/FS-.o      \
+  ${OUT}/FST.o      ${OUT}/FUNCTION.o ${OUT}/GDMP.o     ${OUT}/GOPT.o     \
+  ${OUT}/HACKPI.o   ${OUT}/IDEAL.o    ${OUT}/INFORM.o   ${OUT}/INFORM1.o  \
+  ${OUT}/IPRNTPK.o  ${OUT}/IR.o       ${OUT}/ISUPS.o    ${OUT}/KERNEL.o   \
+  ${OUT}/LIB.o      ${OUT}/LMDICT.o   ${OUT}/LODOOPS.o  ${OUT}/MATRIX.o   \
+  ${OUT}/MKFLCFN.o  ${OUT}/MSET.o     ${OUT}/M3D.o      ${OUT}/NAGC02.o   \
+  ${OUT}/NAGC05.o   ${OUT}/NAGC06.o   ${OUT}/NAGD03.o   ${OUT}/NAGE01.o   \
+  ${OUT}/NAGE02.o   ${OUT}/NAGE04.o   ${OUT}/NAGF07.o   ${OUT}/NAGS.o     \
+  ${OUT}/NAGSP.o    ${OUT}/NREP.o     ${OUT}/NUMFMT.o   ${OUT}/OC.o       \
+  ${OUT}/OC-.o      ${OUT}/ODEPACK.o  ${OUT}/ODERAT.o   ${OUT}/OMERR.o    \
+  ${OUT}/OMERRK.o   ${OUT}/OPTPACK.o  ${OUT}/OSI.o      ${OUT}/PATTERN.o  \
+  ${OUT}/OVAR.o     ${OUT}/PMKERNEL.o ${OUT}/PMSYM.o    ${OUT}/POLY.o     \
+  ${OUT}/PRIMELT.o  ${OUT}/QALGSET2.o ${OUT}/QEQUAT.o   ${OUT}/RECLOS.o   \
+  ${OUT}/REP1.o     ${OUT}/RESULT.o   ${OUT}/QUATCAT.o  ${OUT}/QUATCAT-.o \
+  ${OUT}/RFFACT.o   ${OUT}/RMATRIX.o  ${OUT}/ROMAN.o    ${OUT}/ROUTINE.o  \
+  ${OUT}/RPOLCAT.o  ${OUT}/RPOLCAT-.o ${OUT}/RULECOLD.o ${OUT}/SAOS.o     \
+  ${OUT}/SEGBIND.o  ${OUT}/SET.o      ${OUT}/SPECOUT.o  ${OUT}/SQMATRIX.o \
+  ${OUT}/SWITCH.o   ${OUT}/SYMS.o     ${OUT}/SYMTAB.o   ${OUT}/SYSSOLP.o  \
+  ${OUT}/UTSCAT.o   ${OUT}/UTSCAT-.o  ${OUT}/VARIABLE.o \
   layer16done
 
 @
 \subsection{Layer17}
-\subsubsection{Completed spad files}
-\begin{verbatim}
-aggcat2.spad.pamphlet (FLAGG2 FSAGG2)
-galfact.spad.pamphlet (GALFACT)
-intfact.spad.pamphlet (PRIMES IROOT INTFACT)
-padiclib.spad.pamphlet (IBPTOOLS IBACHIN PWFFINTB)
-permgrps.spad.pamphlet (PERMGRP PGE)
-random.spad.pamphlet (RANDSRC RDIST INTBIT RIDIST RFDIST)
-sgcf.spad.pamphlet (SGCF)
-\end{verbatim}
 
 <<layer17>>=
 
 LAYER17=\
-  ${OUT}/CCLASS.o  ${OUT}/FSAGG2.o  ${OUT}/GALFACT.o ${OUT}/IALGFACT.o \
-  ${OUT}/IBACHIN.o ${OUT}/MMLFORM.o \
-  ${OUT}/NORMMA.o  ${OUT}/ODERED.o  ${OUT}/OMSAGG.o   \
-  ${OUT}/PERM.o    ${OUT}/PERMGRP.o ${OUT}/PRIMES.o  ${OUT}/PWFFINTB.o \
-  ${OUT}/RDIST.o   ${OUT}/SAE.o     ${OUT}/SAEFACT.o ${OUT}/SAERFFC.o  \
-  ${OUT}/SGCF.o    ${OUT}/TBAGG.o   ${OUT}/TBAGG-.o  ${OUT}/VIEW3D.o  \
   layer17done
 
 @
 \subsection{Layer18}
-\subsubsection{Completed spad files}
-\begin{verbatim}
-d01package.spad.pamphlet (INTPACK)
-list.spad.pamphlet (ILIST LIST LIST2 LIST3 LIST2MAP ALIST)
-\end{verbatim}
 
 <<layer18>>=
 
 LAYER18=\
-  ${OUT}/ALIST.o   ${OUT}/EQTBL.o   ${OUT}/GSTBL.o   ${OUT}/HASHTBL.o \
-  ${OUT}/INTABL.o  ${OUT}/INTFTBL.o ${OUT}/INTPACK.o ${OUT}/IPF.o     \
-  ${OUT}/KAFILE.o  ${OUT}/PATRES.o  ${OUT}/STBL.o    ${OUT}/STRTBL.o  \
-  ${OUT}/TABLE.o   ${OUT}/TBCMPPK.o  \
   layer18done
 
 @
 \subsection{Layer19}
-\subsubsection{Completed spad files}
-\begin{verbatim}
-acplot.spad.pamphlet (REALSOLV ACPLOT)
-alql.spad.pamphlet (DLIST ICARD DBASE QEQUAT MTHING OPQUERY)
-any.spad.pamphlet (NONE NONE1 ANY ANY1)
-c02.spad.pamphlet (NAGC02)
-c05.spad.pamphlet (NAGC05)
-c06.spad.pamphlet (NAGC06)
-d02package.spad.pamphlet (ODEPACK)
-d03agents.spad.pamphlet (D03AGNT)
-d03package.spad.pamphlet (PDEPACK)
-drawopt.spad.pamphlet (DROPT DROPT1 DROPT0)
-eigen.spad.pamphlet (EP CHARPOL)
-e01.spad.pamphlet (NAGE01)
-e02.spad.pamphlet (NAGE02)
-e04.spad.pamphlet (NAGE04)
-e04agents.spad.pamphlet (E04AGNT)
-e04package.spad.pamphlet (OPTPACK)
-fnla.spad.pamphlet (OSI COMM HB FNLA)
-fortpak.spad.pamphlet (FCPAK1 NAGSP FORT FOP TEMUTL MCALCFN)
-fr.spad.pamphlet (FR FRUTIL FR2)
-f07.spad.pamphlet (NAGF07)
-intaux.spad.pamphlet (IR IR2)
-intclos.spad.pamphlet (TRIMAT IBATOOL FFINTBAS WFFINTBS NFINTBAS)
-integer.spad.pamphlet (INTSLPE INT NNI PI ROMAN)
-kl.spad.pamphlet (CACHSET SCACHE MKCHSET KERNEL KERNEL2)
-mkfunc.spad.pamphlet (INFORM INFORM1 MKFUNC MKUCFUNC MKBCFUNC MKFLCFN)
-modgcd.spad.pamphlet (INMODGCD)
-multpoly.spad.pamphlet (POLY POLY2 MPOLY SMP INDE)
-newdata.spad.pamphlet (IPRNTPK TBCMPPK SPLNODE SPLTREE)
-op.spad.pamphlet (BOP BOP1 COMMONOP)
-out.spad.pamphlet (OUT SPECOUT DISPLAY)
-outform.spad.pamphlet (NUMFMT OUTFORM)
-patmatch1.spad.pamphlet (PATRES PATRES2 PATLRES PATMAB FPATMAB PMSYM PMKERNEL
-                         PMDOWN PMTOOLS PMLSAGG)
-pattern.spad.pamphlet (PATTERN PATTERN1 PATTERN2 PATAB)
-qalgset.spad.pamphlet (QALGSET QALGSET2)
-reclos.spad.pamphlet (POLUTIL RRCC RCFIELD ROIRC RECLOS)
-rep1.spad.pamphlet (REP1)
-s.spad.pamphlet (NAGS)
-seg.spad.pamphlet (SEGCAT SEGXCAT SEG SEG2 SEGBIND SETBIND2 UNISEG UNISEG2
-                   INCRMAPS)
-syssolp.spad.pamphlet (SYSSOLP)
-\end{verbatim}
 
 <<layer19>>=
 
 LAYER19=\
-  ${OUT}/ACF.o      ${OUT}/ACF-.o     ${OUT}/ACPLOT.o   ${OUT}/ANTISYM.o \
-  ${OUT}/ANY.o      ${OUT}/ASP12.o    ${OUT}/ASP27.o    ${OUT}/ASP28.o   \
-  ${OUT}/ASP33.o    ${OUT}/ASP49.o    ${OUT}/ASP55.o    ${OUT}/ASP7.o    \
-  ${OUT}/ASP78.o    ${OUT}/ASP8.o     ${OUT}/ASP9.o     ${OUT}/ATTRBUT.o \
-  ${OUT}/BOP.o      ${OUT}/BOP1.o     ${OUT}/COMMONOP.o ${OUT}/COMPCAT.o \
-  ${OUT}/COMPCAT-.o ${OUT}/DRAW.o     ${OUT}/DRAWCFUN.o ${OUT}/DROPT.o   \
-  ${OUT}/DROPT0.o   ${OUT}/D01ANFA.o  ${OUT}/D01ASFA.o  ${OUT}/D03AGNT.o \
-  ${OUT}/EP.o       ${OUT}/E04AGNT.o  ${OUT}/FCPAK1.o   ${OUT}/FEXPR.o   \
-  ${OUT}/FFCAT.o    ${OUT}/FFCAT-.o   ${OUT}/FFCGP.o    ${OUT}/FFNBP.o   \
-  ${OUT}/FFP.o      ${OUT}/FLOAT.o    ${OUT}/FPARFRAC.o ${OUT}/FR.o      \
-  ${OUT}/FRNAALG.o  ${OUT}/FRNAALG-.o ${OUT}/FS.o       ${OUT}/FS-.o     \
-  ${OUT}/FST.o      ${OUT}/FUNCTION.o ${OUT}/GDMP.o     ${OUT}/GOPT.o    \
-  ${OUT}/HACKPI.o  \
-  ${OUT}/IDEAL.o    ${OUT}/INFORM.o   ${OUT}/INFORM1.o  ${OUT}/IPRNTPK.o \
-  ${OUT}/IR.o       ${OUT}/ISUPS.o    ${OUT}/KERNEL.o   ${OUT}/LIB.o     \
-  ${OUT}/LMDICT.o   ${OUT}/LODOOPS.o  ${OUT}/MATRIX.o   ${OUT}/MKFLCFN.o \
-  ${OUT}/MSET.o     ${OUT}/M3D.o      ${OUT}/NAGC02.o   ${OUT}/NAGC05.o  \
-  ${OUT}/NAGC06.o   ${OUT}/NAGD03.o   ${OUT}/NAGE01.o   ${OUT}/NAGE02.o  \
-  ${OUT}/NAGE04.o   ${OUT}/NAGF07.o   ${OUT}/NAGS.o     ${OUT}/NAGSP.o   \
-  ${OUT}/NREP.o     ${OUT}/NUMFMT.o   ${OUT}/OC.o       ${OUT}/OC-.o     \
-  ${OUT}/ODEPACK.o  ${OUT}/ODERAT.o   ${OUT}/OMERR.o    ${OUT}/OMERRK.o  \
-  ${OUT}/OPTPACK.o  ${OUT}/OSI.o      ${OUT}/PATTERN.o  ${OUT}/OVAR.o    \
-  ${OUT}/PMKERNEL.o ${OUT}/PMSYM.o    ${OUT}/POLY.o     ${OUT}/PRIMELT.o \
-  ${OUT}/QALGSET2.o ${OUT}/QEQUAT.o   ${OUT}/RECLOS.o   ${OUT}/REP1.o    \
-  ${OUT}/RESULT.o   ${OUT}/QUATCAT.o  ${OUT}/QUATCAT-.o ${OUT}/RFFACT.o  \
-  ${OUT}/RMATRIX.o  ${OUT}/ROMAN.o    ${OUT}/ROUTINE.o  ${OUT}/RPOLCAT.o \
-  ${OUT}/RPOLCAT-.o ${OUT}/RULECOLD.o ${OUT}/SAOS.o     ${OUT}/SEGBIND.o \
-  ${OUT}/SET.o      ${OUT}/SPECOUT.o  ${OUT}/SQMATRIX.o ${OUT}/SWITCH.o  \
-  ${OUT}/SYMS.o     ${OUT}/SYMTAB.o   ${OUT}/SYSSOLP.o  ${OUT}/UTSCAT.o  \
-  ${OUT}/UTSCAT-.o  ${OUT}/VARIABLE.o ${OUT}/WFFINTBS.o  \
   layer19done
 
 
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index 4ca6300..1a34cd9 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -855,6 +855,8 @@ algebra/Makefile move layers 7,8,9 <br/>
 algebra/Makefile move layer 10, MAPPKG4 <br/>
 <a href="patches/20081225.03.tpd.patch">20081225.03.tpd.patch</a>
 algebra/Makefile move layers 11, 12, 13 <br/>
+<a href="patches/20081225.04.tpd.patch">20081225.04.tpd.patch</a>
+algebra/Makefile move layers 15, 16, 17, 18, 19 <br/>
 
  </body>
 </html>
